//////////////////////////////////////////////////////////////////////
// PskDet.h: interface for the CBPSKDet class.
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BpskDet_H__0C099641_E9AB_11D2_88B9_444553540000__INCLUDED_)
#define AFX_BpskDet_H__0C099641_E9AB_11D2_88B9_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <math.h>
#include "PskDetTbl.h"
#include "FECDecode.h"


class CBPSKDet  
{
public:
	CBPSKDet();
	virtual ~CBPSKDet();

	void Init(INT Fs ,int BlockSize, HWND hWnd );
	void ResetDetector();
	void GetRXFrequency(int* pfreq, double* pdopplerate){*pfreq = m_RxFrequency;
								*pdopplerate = m_DopplerRate;};
	void GetVectorData(long* VectData);
	void SetRXFrequency(int freq);
	void SetBitAdj(INT Adj);
	void AdjDopplerJmp( int step );
	BOOL GetDataBlock( char* pData);
	int FindCenterFrequency(double* pIn);
	int ProcBPSKDet( double* pIn, BOOL UseFreqSearch);
	int GetBitPosition(){ return m_PkPos;};
	int GetSNR(){ return m_SNR;};
	int GetDecoderState(){return m_DecodeCRCState;};
	double ZeroSNR(double FilterFactor);
//public variables
	HWND m_hWnd;	//window handle for sending messages to app

private:
//methods
	void DecodeSymb( _complex newsamp );
	void CalcPhaseError( _complex IQ );
	BOOL SymbSync(_complex sample);
	WORD CalcCRC(BYTE* buf, int length);
	int ProcessCRCsymbol(BOOL bit);
//variables
	BOOL m_CRCok;
	BYTE m_DataBuf[514];
	UINT m_BitAcc;
	LONG m_IQPhaseArray[16];
	int m_BitPhzErrCnt;
	int m_DecodeCRCState;
	int m_DecodeFECState;
	int m_BitCnt;
	int m_ByteCnt;
	int m_IQPhzIndex;
	int m_LastPkPos;
	int m_BlockSize;
	int m_RxFrequency;
	int m_FirState;
	int m_SNR;
	int m_FreqSearchTimer;
	int m_FECActiveTimer;
	double m_PhaseError;
	double m_BitPhaseInc;
	double m_BitPhasePos;
	double m_SyncAve[22];
	double m_PhzErrAve;
	double m_NCOphzinc;
	double m_SampleFreq;
	double m_DopplerRate;
	double m_EnergyIn;
	double m_EnergyOut;
	double m_Sin[256];
	double m_Cos[256];
	double m_FilterGainFactor;

	_complex m_LastIQ;		//  PreviousI/Q  variables
	_complex m_pQue[LPFIR_LEN];
	CFECDecode m_FECdecoder;

// Local variables for various functions that need to be saved between calls
	double m_VcoPhz;
	int	m_PkPos;
	int	m_NewPkPos;
	int m_BitPos;
};

#endif // !defined(AFX_BpskDet_H__0C099641_E9AB_11D2_88B9_444553540000__INCLUDED_)
