#if !defined( __BPSK400_H__ )
#define __BPSK400_H__
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

///////////////////////////////////////
// Header file for using BPSK400.DLL //
///////////////////////////////////////
#ifdef COREDLL_EXPORTS
#define COREDLL_API __declspec(dllexport)
#else
#define COREDLL_API __declspec(dllimport)
#endif


// Function prototypes

// Initialization/Shutdown
extern "C" long COREDLL_API __stdcall fnStartSoundReceive(HWND hWnd, long cardnum, long EchoWave, long UseAFC  );
extern "C" long COREDLL_API __stdcall fnStartWaveReceive(HWND hWnd, const char* sPath, long UseAFC, long Offset);
extern "C" void COREDLL_API __stdcall fnStopReceive();
extern "C" void COREDLL_API __stdcall fnSetRxMode(long UseAFC);
extern "C" long COREDLL_API __stdcall fnCheckWavePath( const char* sPath, long* pFileSize);
extern "C" long COREDLL_API __stdcall fnSetOutWavePath( const char* sPath, long AppendMode);
extern "C" void COREDLL_API __stdcall fnPauseOutWave( long state);

extern "C" void COREDLL_API __stdcall fnSetRigCtrlOptions( long port, long mode,long centerfreq,long usb,long params, INT stepsz);
extern "C" long COREDLL_API __stdcall fnSetManualRate( long rate);
extern "C" long COREDLL_API __stdcall fnGetDopCorrectionRate();
extern "C" long COREDLL_API __stdcall fnCheckComPort( long port);
extern "C" void COREDLL_API __stdcall fnSetCmdStrings(const char* sUp, const char* sDn );

// Receive
extern "C" void COREDLL_API __stdcall fnSetRXFrequency(long freq);
extern "C" void COREDLL_API __stdcall fnGetRXFrequency(long* pfreq, double* pdopplerate);
extern "C" void COREDLL_API __stdcall fnSetFFTParams(LONG ave, double gain, LONG type );
extern "C" long COREDLL_API __stdcall fnGetFFTData(long* array, long start, long end);
extern "C" long COREDLL_API __stdcall fnGetDataBlock(char* pData);
extern "C" void COREDLL_API __stdcall fnSetBitAdj(long adj);

// Miscellaneous
extern "C" long COREDLL_API __stdcall fnGetDLLVersion();
extern "C" void COREDLL_API __stdcall fnGetErrorString(char* ErrorStr);
extern "C" long COREDLL_API __stdcall fnGetDebugData(double* val1, double* val2);
extern "C" void COREDLL_API __stdcall fnGetVectorData(long* vectorarray);
extern "C" long COREDLL_API __stdcall fnGetBitPosition();
extern "C" double COREDLL_API __stdcall fnZeroSNR(double filterfactor);



// Message definitions

#define MSG_FFTDATARDY		( WM_USER + 1000 )
#define MSG_STATUSCHANGE	( WM_USER + 1001 )  
#define MSG_DATARDY			( WM_USER + 1002 )

#define CRCBLOCK 0
#define FECBLOCK 1


// Rig Control Mode definitions
#define RIGCTRL_MODE_MANUAL 0
#define RIGCTRL_MODE_PROPORTIONAL 1
#define RIGCTRL_MODE_ACTIVEMASK 0x80
#define RIGCTRL_WIDTH_MAX 30
#define RIGCTRL_WIDTH_MIN 25


//Status message defines
#define DLLSTAT_OFF -1			//DLL status/error codes
#define DLLSTAT_RXCRC_MASK 0x0F
#define DLLSTAT_RXCRC_NO_SIGNAL 0
#define DLLSTAT_RXCRC_SYNC_SEARCH 1
#define DLLSTAT_RXCRC_BLOCK_READ 2
#define DLLSTAT_CPUSLOW 3
#define DLLSTAT_WAVEFINISHED 4
#define DLLSTAT_RXFEC_MASK 0xF0
#define DLLSTAT_RXFEC_NO_SIGNAL 0x00	//new FEC status(upper 4 bits)
#define DLLSTAT_RXFEC_SYNC_SEARCH 0x10	//or'ed togther into one status
#define DLLSTAT_RXFEC_BLOCK_READ 0x20

#define DLLERR_NONE 0 
#define DLLERR_MEMORY 10 

#define DLLERR_IN_NOTOPEN 11
#define DLLERR_IN_OVERFLOW 12
#define DLLERR_IN_TIMEOUT 13
#define DLLERR_OUT_NOTOPEN 14
#define DLLERR_OUT_UNDERFLOW 15
#define DLLERR_OUT_TIMEOUT 16

#define DLLERR_WAV_BADFORMAT 17
#define DLLERR_WAV_STILLPLAYING 18
#define DLLERR_WAV_UNPREPARED 19
#define DLLERR_WAV_SYNC 20

#define DLLERR_SYS_BADDEVICEID 21
#define DLLERR_SYS_NOTENABLED 22
#define DLLERR_SYS_ALLOCATED 23
#define DLLERR_SYS_INVALHANDLE 24
#define DLLERR_SYS_NODRIVER 25
#define DLLERR_SYS_NOTSUPPORTED 26
#define DLLERR_SYS_BADERRNUM 27
#define DLLERR_SYS_INVALFLAG 28 
#define DLLERR_SYS_INVALPARAM 29
#define DLLERR_SYS_HANDLEBUSY 30
#define DLLERR_SYS_REGISTRY 31
#define DLLERR_SYS_NODRIVERCB 32

#define DLLERR_UNKNOWN 33
#endif //!defined( __BPSK400_H__ )
