// PlotData.h: interface for the CPlotData class.
//
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLOTDATA_H__91277FC1_4F28_11D3_A232_00A0C996E7F5__INCLUDED_)
#define AFX_PLOTDATA_H__91277FC1_4F28_11D3_A232_00A0C996E7F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AO40RcvDoc.h"

#define DISPBUF_SIZE (512)	// 1024 pt FFT /2

class CPlotData  
{
public:
	void ClearBufs();
	void RedrawScreen();
	INT GetCursFreq(CPoint point);
	void SetCursFreq(INT freq);
	CPlotData();
	virtual ~CPlotData();
	void OnDrawPlot(HWND hWnd, CRect crPlot, CAO40RcvDoc* pDoc);
	BOOL CurInFreqPlot(CPoint pt){return m_rFreqPlot.PtInRect(pt);}
	void DrawPlot();

private:
	BOOL m_RedrawScreen;
// functions
	void PlotFFTWater( CDC* pDC);
	void PlotOverlayVectData( CDC* pDC );
// variables
	BOOL m_LastOvrLoad;
	BOOL m_NeedToClrBufs;
	BOOL m_BufToggle;
	INT m_CurPos;
	INT m_FFTAveVal;
	INT m_TranslateTbl[DISPBUF_SIZE+10];
	POINT m_BitPosTable[20];
	double m_TicCounter;
	double m_Ave;
	CPen* m_pPenG;			//different colored pens used for drawing plots
	CPen* m_pPenY;
	CPen* m_pPenW;
	CPen* m_pPenR;
	CPen* m_pPenC;
	CPen* m_pPenB;
	CPen* m_pPenRW;
	INT* m_pDispBuf;
	CRect m_rFreqPlot;			// client freq plot screen rectangle coordinates
	RECT m_rFreqPlotsize;		// size of the freq plot screen bitmap
	CBitmap m_bmPlot;		// bitmap image of freq plot window
	CBitmap m_bmWaterA;		// bitmap image for waterfall ping pong buf A
	CBitmap m_bmWaterB;		// bitmap image for waterfall ping pong buf B
	CAO40RcvDoc *m_pDoc;
	CDC* m_pDC;
	HWND m_hViewWnd;
};

#endif // !defined(AFX_PLOTDATA_H__91277FC1_4F28_11D3_A232_00A0C996E7F5__INCLUDED_)
