// TLMdecode.h: interface for the CTLMdecode class.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TLMDECODE_H__4397C9DF_770B_4609_86B6_0303B1BE66F1__INCLUDED_)
#define AFX_TLMDECODE_H__4397C9DF_770B_4609_86B6_0303B1BE66F1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "TextTables.h"
#include "math.h"

#define BIT0 (1<<0)
#define BIT1 (1<<1)
#define BIT2 (1<<2)
#define BIT3 (1<<3)
#define BIT4 (1<<4)
#define BIT5 (1<<5)
#define BIT6 (1<<6)
#define BIT7 (1<<7)
#define BIT8 (1<<8)
#define BIT9 (1<<9)
#define BIT10 (1<<10)
#define BIT11 (1<<11)
#define BIT12 (1<<12)
#define BIT13 (1<<13)
#define BIT14 (1<<14)
#define BIT15 (1<<15)

class CTLMdecode  
{
public:
	void CopyData(PBYTE pBuf);
	CTLMdecode();
	virtual ~CTLMdecode();
	void MakeNavStr(CString& str, BOOL crcok);
	void MakeTempStr(CString& str, BOOL crcok);
	void MakePwrStr(CString& str, BOOL crcok);
	void MakeMailStr(CString& str, BOOL crcok);
	void MakeMatrixStr(CString& str, BOOL crcok);
	void MakeStatusAStr(CString& str, BOOL crcok);
	void MakeStatusEStr(CString& str, BOOL crcok);
	void MakeRawStr(CString& str, BOOL crcok);

private:
	INT AtoB( INT x, INT mul);
	void GetAmsatDay( CTime& ta);
	double BT(double b){ return (0.659*b-69.7);};
	double BT2(double b){ return (-0.413*b+103.8);};
	double BV1(double b){ return (0.1548*b-1.484);};
	double BV2(double b){ return (0.1522*b-1.06);};
	double BV3(double b){ return (0.1318*b-0.923);};
	double BV4(double b){ return (0.0657*b-0.712);};
	double BV5(double b){ return (1.221*b-263.0537);};
	double BI1(double b){ return (0.1014*b-0.6212);};
	double BI2(double b){ return (0.0125*b-0.0875);};
	double BI3(double b){ return (0.241*b-31.28);};
	double BI4(double b){ return (0.2035*b-2.85);};
	double BI5(double b){ return (0.197*b-0.739);};
	double BI6(double b){ return (0.0412*b-0.76);};
	double BI7(double b){ return (0.1024*b-0.653);};
	double BI8(double b){ return (0.0429*b-0.333);};
	double BI9(double b){ return (0.103*b-0.95);};
	double BI10(double b){ return (0.0503*b-0.3154);};
	double BI11(double b){ return (10.337 - b*0.0366);};
	double BR1(double b){ return ( pow( b/151.533152, -4.945347071));};
	double SSA1(double b){ return ( b*b*b*.00000361-b*b*.001539+b*.3682-31.501);};
	double SSA2(double b){ return ( b*b*b*.00000581-b*b*.002447+b*.64187-55.179);};
	double SSA3(double b){ return ( 57.2957795*acos(b/255.0) );};
//	double BAR1(double b){ return ( (b*.815)-1.381 );}; //spec
	double BAR1(double b){ return ( (b*.0815)-1.253 );}; //P3T corrected by Stacey Mills 4/29/01
//	double BAR2(double b){ return ( b*.835-1.253 );}; //spec
	double BAR2(double b){ return ( b*.0835-1.381 );}; //P3T corrected by Stacey Mills 4/29/01
	double BAR3(double b){ return ( b*2.3406 -197.1);};
	double BAR4(double b){ return ( b*.1235-1.235 );};
	double AGC1(double b){ return ( b*.254-14.8 );};
	double AGC2(double b){ return ( b*.457-31.9 );};
	double AGC3(double b){ return ( b*.129-7.9 );};
	double AGC4(double b){ return ( b*.154-10.6 );};
	double AGC5(double b){ return ( b*b*.004+b*1.2-72.0 );};
	double AGC6(double b){ return ( b*b*.011+b*3.7-284.0 );};
	double CalcSEUSens(void);
	const char* GetPointing(void);
	double CalcSunSens(void);
	double CalcWRPM(INT adr);
	double CalcBatOffset(void);
	double CalcBCROffset(INT adr);
	double CalcSunAngle(void);

	void MakeStatusScrn(CString& str);
	const char* GetMsg(INT adr, INT bit, t_msg MsgArray);
	const char* GetMsg2(INT adr1,INT bit1,INT adr2,INT bit2,t_msg2 MsgArray);
	void SetBit(INT inptr, BYTE inbit, INT outptr, INT outbit);
	void CalcIFMatrix();
	union Uword{
		struct{
			BYTE lsb;
			BYTE msb;
		}bytes;
		short both;
	};
	BYTE m_pDat[514];
	DWORD m_IFMatrixBits[14];
	CHAR m_IFMatrixStr[14][38];

};

#endif // !defined(AFX_TLMDECODE_H__4397C9DF_770B_4609_86B6_0303B1BE66F1__INCLUDED_)
